module Main where

import Data.List
import Control.Applicative

readAll :: Int -> IO [String]
readAll k 
    | k <= 0 = return []
    | otherwise = do
        linez <- getLine
        fmap (linez :) $ readAll (k-1) 

main :: IO ()
main = do
    firstLine <- fmap words getLine
    linez <- (return $ read $ firstLine !! 0) :: IO Int
    colz <- (return $ read $ firstLine !! 1) :: IO Int
    pals <- (return $ read $ firstLine !! 2) :: IO Int
    wordz <- readAll linez
    searchW <- readAll pals
    wordzCol <- return $ transpose wordz
    wordzList <- return $ wordz ++ wordzCol
    searchList <- return $ map (\x -> [x, reverse x]) searchW
    boolList <- return $ map (\x -> isInfixOf <$> x <*> wordzList) searchList
    putStrLn $ show $ sum $ map fromEnum $ map or boolList