module Main where
import Data.List

to33 :: [[Int]] -> [[Int]]
to33 xs = [[xs !! 0 !! 0, xs !! 0 !! 1, xs !! 0 !! 2, xs !! 1 !! 0, xs !! 1 !! 1, xs !! 1 !! 2, xs !! 2 !! 0, xs !! 2 !! 1, xs !! 2 !! 2],
           [xs !! 0 !! 3, xs !! 0 !! 4, xs !! 0 !! 5, xs !! 1 !! 3, xs !! 1 !! 4, xs !! 1 !! 5, xs !! 2 !! 3, xs !! 2 !! 4, xs !! 2 !! 5],
           [xs !! 0 !! 6, xs !! 0 !! 7, xs !! 0 !! 8, xs !! 1 !! 6, xs !! 1 !! 7, xs !! 1 !! 8, xs !! 2 !! 6, xs !! 2 !! 7, xs !! 2 !! 8],
           [xs !! 3 !! 0, xs !! 3 !! 1, xs !! 3 !! 2, xs !! 4 !! 0, xs !! 4 !! 1, xs !! 4 !! 2, xs !! 5 !! 0, xs !! 5 !! 1, xs !! 5 !! 2],
           [xs !! 3 !! 3, xs !! 3 !! 4, xs !! 3 !! 5, xs !! 4 !! 3, xs !! 4 !! 4, xs !! 4 !! 5, xs !! 5 !! 3, xs !! 5 !! 4, xs !! 5 !! 5],
           [xs !! 3 !! 6, xs !! 3 !! 7, xs !! 3 !! 8, xs !! 4 !! 6, xs !! 4 !! 7, xs !! 4 !! 8, xs !! 5 !! 6, xs !! 5 !! 7, xs !! 5 !! 8],
           [xs !! 6 !! 0, xs !! 6 !! 1, xs !! 6 !! 2, xs !! 7 !! 0, xs !! 7 !! 1, xs !! 7 !! 2, xs !! 8 !! 0, xs !! 8 !! 1, xs !! 8 !! 2],
           [xs !! 6 !! 3, xs !! 6 !! 4, xs !! 6 !! 5, xs !! 7 !! 3, xs !! 7 !! 4, xs !! 7 !! 5, xs !! 8 !! 3, xs !! 8 !! 4, xs !! 8 !! 5],
           [xs !! 6 !! 6, xs !! 6 !! 7, xs !! 6 !! 8, xs !! 7 !! 6, xs !! 7 !! 7, xs !! 7 !! 8, xs !! 8 !! 6, xs !! 8 !! 7, xs !! 8 !! 8]]

check :: [Int] -> Bool
check []     = True
check (x:xs) = x `notElem` xs && check xs

printAns :: Bool -> String
printAns True = "SIM"
printAns False = "NAO"

main :: IO ()
main = do
      l1 <- fmap (map read . words) getLine :: IO [Int]
      l2 <- fmap (map read . words) getLine :: IO [Int]
      l3 <- fmap (map read . words) getLine :: IO [Int]
      l4 <- fmap (map read . words) getLine :: IO [Int]
      l5 <- fmap (map read . words) getLine :: IO [Int]
      l6 <- fmap (map read . words) getLine :: IO [Int]
      l7 <- fmap (map read . words) getLine :: IO [Int]
      l8 <- fmap (map read . words) getLine :: IO [Int]
      l9 <- fmap (map read . words) getLine :: IO [Int]
      linhas <- return $ [l1,l2,l3,l4,l5,l6,l7,l8,l9]
      r33 <- return $ to33 linhas
      cols <- return $ transpose linhas
      result <- return $ and (map check linhas) && and (map check r33) && and (map check cols) 
      putStrLn $ printAns result